// TreeCtrlDrag.cpp : implementation file
//

#include "stdafx.h"
#include "TreeCtrlDrag.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTreeCtrlDrag

CTreeCtrlDrag::CTreeCtrlDrag()
{
  m_pDragImgList = NULL;
}

//

CTreeCtrlDrag::~CTreeCtrlDrag()
{
}

//

BEGIN_MESSAGE_MAP(CTreeCtrlDrag, CTreeCtrl)
	//{{AFX_MSG_MAP(CTreeCtrlDrag)
	ON_WM_MOUSEWHEEL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTreeCtrlDrag message handlers

void CTreeCtrlDrag::CopyItem(HTREEITEM hDest,HTREEITEM hSrc)
{
  TV_ITEM tvSrc;
  tvSrc.mask  = TVIF_HANDLE | TVIF_PARAM | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_STATE;
  tvSrc.hItem = hSrc;
  if(!GetItem(&tvSrc)) return;

  tvSrc.hItem = hDest;
  SetItem(&tvSrc);
  SetItemText(hDest,GetItemText(hSrc));
  SetCheck   (hDest,GetCheck   (hSrc));

  if(tvSrc.state & TVIS_EXPANDED) Expand(hDest,TVE_EXPAND);
}

//

void CTreeCtrlDrag::CopySubtree(HTREEITEM hDest,HTREEITEM hSrc)
{
  if(!hDest || !hSrc) return;

  HTREEITEM hChildSrc = GetChildItem(hSrc);
  while(hChildSrc)
  {
    HTREEITEM   hChildDest = InsertItem("dest child",hDest);
    CopySubtree(hChildDest,hChildSrc);
    CopyItem   (hChildDest,hChildSrc);

    hChildSrc = GetNextSiblingItem(hChildSrc);
  }
}

//

HTREEITEM CTreeCtrlDrag::InsertItemAndSubtree(HTREEITEM hDest,HTREEITEM hSrc)
{
  if(!hDest || !hSrc) return NULL;

  HTREEITEM hNew = InsertItem("new",hDest);
  if(!hNew) return NULL;

  CopySubtree(hNew,hSrc);                                   // start with subtree so that item is correctly expanded
  CopyItem   (hNew,hSrc);
  return hNew;
}

//
//

BOOL CTreeCtrlDrag::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
  if(m_pDragImgList) m_pDragImgList->DragShowNolock(false);
	BOOL Res = CTreeCtrl::OnMouseWheel(nFlags, zDelta, pt);
  if(m_pDragImgList) m_pDragImgList->DragShowNolock(true);
  return Res;
}
