// DragDropView.h : interface of the CDragDropView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DRAGDROPVIEW_H__3DEF942F_73BE_11D6_9CD8_444553540000__INCLUDED_)
#define AFX_DRAGDROPVIEW_H__3DEF942F_73BE_11D6_9CD8_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CDragDropView : public CTreeView
{
protected: // create from serialization only
	CDragDropView();
	DECLARE_DYNCREATE(CDragDropView)

// Attributes
public:
	CDragDropDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDragDropView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDragDropView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

  void              DragToggleItem      (void);
  void              SuccessfulDrag      (HTREEITEM hDest,HTREEITEM hSrc);
  HTREEITEM         InsertItemAndSubtree(HTREEITEM hDest,HTREEITEM hSrc);
  void              CopySubtree         (HTREEITEM hDest,HTREEITEM hSrc);
  void              CopyItem            (HTREEITEM hDest,HTREEITEM hSrc);

protected:

  CImageList        m_imgList;

  // drag & drop

  UINT              m_nTimer;
  bool              m_boDragging;
  CImageList*       m_pDragImgList;
  HTREEITEM         m_hDragItem;
  HTREEITEM         m_hDragTarget;

// Generated message map functions
protected:
	//{{AFX_MSG(CDragDropView)
	afx_msg void OnKeydown(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DragDropView.cpp
inline CDragDropDoc* CDragDropView::GetDocument()
   { return (CDragDropDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DRAGDROPVIEW_H__3DEF942F_73BE_11D6_9CD8_444553540000__INCLUDED_)
